-- 武林大会
checkRequire("Lua_WulindahuiUtil");
Lua_CopyWulinWindow = class("Lua_CopyWulinWindow", Lua_SecondSizeWindow);
function Lua_CopyWulinWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_CopyWulinWindow";
	self.skinName = "CopyWulinWindow_skin";
	self.titleText = LanUtil.getValue(122800)
end

function Lua_CopyWulinWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.descBg.imgTypeNum = 4;
	self.descBg.widget.border = Vector4(0, 10, 0, 10);

	self.actTimeSpr:SetActive(false);
	self.objcenter:SetActive(false);
	self.quxiaoBtn:setEnable(false);

	self.shenglv.text = LanUtil.formateStr(LanUtil.getValue(122802), "0");
	self.jifeng.text = LanUtil.formateStr(LanUtil.getValue(122803), "0");
	self.canyulable.text = LanUtil.formateStr(LanUtil.getValue(122801), "0");

	local activityVo = DataCenter.xianshiData:getDataById(getConfig({"wulin_congress", "activity_id", "value"}));
	self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(122822), activityVo.openTimeDesc);

	local box_index = DataCenter.WulindahuiUtil.boxIndex;
	local maxNum = box_index[#box_index];
	self.xueBar:setValue(0);
	self.xueBar:setMaxValue(maxNum);
	self.totalNum.text = LanUtil.formateStr(LanUtil.getValue(122823), Lua_CommonUtil.transChineseNumber(maxNum));

	local posX;
	local box;
	self.boxArr = Array();
	for i = 1, #box_index do
		posX = -14 + self.xueBar.mainContent.transform.localPosition.x - self.xueBar.width / 2 +
		(box_index[i] / maxNum) * self.xueBar.width;

		box = Lua_WulindahuiBoxItem.new(self.content);
		box.index = box_index[i];
		box:setData(box_index[i]);
		box:setLocation(posX, -150);
		self.boxArr:add(box);
	end

	local limitAutoVip = getConfig({"wulin_congress", "auto_vip", "value"});
	local name = getConfig({"vip_level", limitAutoVip, "view_name"});
	self.cBox.seleted = DataCenter.WulindahuiData.autoStart;
	self.cBox.label = LanUtil.formateStr(LanUtil.getValue(122825), name);
	self.cBox:addBoxChange(self, self.onAutoChange);

	self.paimingBtn:addClickFuntion(self, self.onpaimingClick);
	self.jiangliBtn:addClickFuntion(self, self.onjiangliClick);
	self.tipsIcon:addClickFuntion(self, self.onTipsClick);
	self.pipeiBtn:addClickFuntion(self, self.onpipeiButtonClick);
	self.quxiaoBtn:addClickFuntion(self, self.onquxiaoButtonClick);

	self:onUpdateActTime();

	self:addLuaEvent("ACT_STATE_CHANGE", self, self.onUpdateActTime);
	self:addLuaEvent("rWulinInfoUpdate", self, self.onUpdateWulinInfo);
	self:addLuaEvent("rChallengMatchOrCancle", self, self.onChallengMatchOrCancle);
	self:addLuaEvent("rGetWulinReward", self, self.onGetWuLinReward);
	self:addLuaEvent("SCENE_CHANGE", self, self.onSceneChange);
	self:addLuaEvent("rMatchSuccess", self, self.onMatchSuccess);
	sendMsg(10400303); -- 打开武林大会界面

	if DataCenter.WulindahuiData.autoStart then
		self:onpipeiButtonClick();
	end
end

function Lua_CopyWulinWindow:onAutoChange(val)
	local canAuto = getConfig({"vip_level", DataCenter.vipData.level, "wulin_auto"});
	if canAuto ~= 1 then
		self.cBox.seleted = false;
		OperateAlert.show(LanUtil.getValue(122826));
		return;
	end

	if self.clickTime ~= nil and getTime() - self.clickTime < 1 then
		OperateAlert.show(LanUtil.getValue(121419));
		self.cBox.seleted = false;
		return;
	end
	DataCenter.WulindahuiData.autoStart = val;

	if val and self.challengeType ~= 1 then
		-- self:onpipeiButtonClick();
	end
end

function Lua_CopyWulinWindow:onUpdateActTime()
	local vo = DataCenter.xianshiData:getDataById(getConfig({"wulin_congress", "activity_id", "value"}));
	if vo ~= nil and vo.activity_state ~= nil and vo.activity_state == 2 then
		local leftTime = math.floor(vo:getLeftTime());
		if leftTime <= 0 then
			self:clearTimer();
		else
			self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(122824), TimeTransform.getInstance():transSeconds1(leftTime, true));
			if self.bTimer ~= true then
				self.bTimer = true;
				self:addTimer("updateWulinLeftTime", 0.5, self, self.updateWulinLeftTime);
			end
		end
		self.actTimeSpr:SetActive(leftTime > 0);
	else
		self.actTimeSpr:SetActive(false);
	end
end

function Lua_CopyWulinWindow:updateWulinLeftTime()
	local vo = DataCenter.xianshiData:getDataById(getConfig({"wulin_congress", "activity_id", "value"}));
	local leftTime = math.floor(vo:getLeftTime());
	self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(122824), TimeTransform.getInstance():transSeconds1(leftTime, true));
	if leftTime <= 0 then
		self:clearTimer();
	end
end

function Lua_CopyWulinWindow:clearTimer()
	if self.bTimer == true then
		self.bTimer = false;
		Lua_CommonUtil.removeTimer(self, self.updateWulinLeftTime);
	end
end

function Lua_CopyWulinWindow:onUpdateWulinInfo()
	self.canyulable.text = LanUtil.formateStr(LanUtil.getValue(122801), tostring(DataCenter.WulindahuiData.curChallengeTimes));
	self.shenglv.text = LanUtil.formateStr(LanUtil.getValue(122802), tostring(DataCenter.WulindahuiData.curWinRate));
	self.jifeng.text = LanUtil.formateStr(LanUtil.getValue(122803), tostring(DataCenter.WulindahuiData.curPointNum));

	self.xueBar:setText("");
	self.xueBar:setValue(DataCenter.WulindahuiData.curChallengeTimes);

	self:onGetWuLinReward();
end

function Lua_CopyWulinWindow:onGetWuLinReward()
	for i = 1, self.boxArr:getSize() do 
		self.boxArr[i]:checkLingquState();
	end
	-- self:onShowRedDot()--红点显示
end

-- 红点显示
-- function Lua_CopyWulinWindow:onShowRedDot()
-- 	local boxRewards = DataCenter.WulindahuiData.boxRewards;
-- 	local enterNum = DataCenter.WulindahuiData.curChallengeTimes; -- 当前场次
-- 	for i = 1, self.boxArr:getSize() do 
-- 		if boxRewards ~= nil then
-- 			for i, v in ipairs(boxRewards) do
-- 				self.boxArr[i]:showRedDot(tonumber(v.obj_value) == 1 and self.boxArr[i].index <= enterNum);
-- 			end
-- 		end
-- 	end
-- end

function Lua_CopyWulinWindow:onChallengMatchOrCancle(challengeType)
	self.challengeType = challengeType;
	if challengeType == 1 then -- 开始匹配
		self.objcenter:SetActive(true);
		self.matchSpr:SetActive(true);
		self.matchCompleteObj:SetActive(false);

		self.pipeiBtn:setEnable(false);
		self.quxiaoBtn:setEnable(true);

		self.backTime = 0;
		if self.bRegisterTimer ~= true then
			self.bRegisterTimer = true;
			Lua_CommonUtil.addTimer("updateonpipeiButtonTime", 1, self, self.updateonpipeiButtonTime, nil, -1);
		end
		self:updateonpipeiButtonTime();
	elseif challengeType == 0 then -- 取消匹配
		self.objcenter:SetActive(false);
		self.miaoLabel.text = "";
		self:removeMatchTimer();

		self.pipeiBtn:setEnable(true);
		self.quxiaoBtn:setEnable(false);
	end
end

function Lua_CopyWulinWindow:updateonpipeiButtonTime()
	self.miaoLabel.text = self.backTime .. "s";
	self.backTime = self.backTime + 1;
end

function Lua_CopyWulinWindow:removeMatchTimer()
	if self.bRegisterTimer == true then
		self.bRegisterTimer = false;
		Lua_CommonUtil.removeTimer(self, self.updateonpipeiButtonTime);
	end
end

-- 切换场景
function Lua_CopyWulinWindow:onSceneChange(o)
	if self.challengeType ~= nil and self.challengeType == 1 then
		self:onquxiaoButtonClick(nil);
	end
end

function Lua_CopyWulinWindow:onquxiaoButtonClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 1 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	local cmd = ProtoPublic_pb.Proto10400301();
	cmd.type = 0
	sendMsg(10400301, cmd);
end

function Lua_CopyWulinWindow:onMatchSuccess()
	self.objcenter:SetActive(true);
	self.matchSpr:SetActive(false);
	self.matchCompleteObj:SetActive(true);
	self:removeMatchTimer();

	self.pipeiBtn:setEnable(true);
	self.quxiaoBtn:setEnable(false);
end

function Lua_CopyWulinWindow:onpaimingClick()
	Lua_WindowUtil.openWin("Lua_WulinRankWindow");
end

function Lua_CopyWulinWindow:onjiangliClick()
	Lua_WindowUtil.openWin("Lua_WulinRewardsWindow");
end

function Lua_CopyWulinWindow:onTipsClick()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", nil, LanUtil.getValue(122805));
end

function Lua_CopyWulinWindow:onpipeiButtonClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 1 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	local cmd = ProtoPublic_pb.Proto10400301();
	cmd.type = 1
	sendMsg(10400301, cmd);
end

function Lua_CopyWulinWindow:dispose()
	local cmd = ProtoPublic_pb.Proto10400301();
	cmd.type = 0; -- 0 取消武林大会匹配
	sendMsg(10400301, cmd);

	self:removeMatchTimer();
	self:clearTimer();

	self:superCall("dispose");
end





--------------------------------------------------





Lua_WulindahuiBoxItem = class("Lua_WulindahuiBoxItem", Lua_DisplayObject);
function Lua_WulindahuiBoxItem:ctor(p)
	self:superCall("ctor", p, "WulindahuiBoxItem_skin");
end

function Lua_WulindahuiBoxItem:buildShowItem()
	self:superCall("buildShowItem");

	self.box:addClickFuntion(self, self.onBoxClick);
	self.box:addLoadCompleteFun(self, self.onLoadCompleteImg);
end

function Lua_WulindahuiBoxItem:setData(data)
	self.data = data;
	self.txt.text = LanUtil.formateStr(LanUtil.getValue(122804), tostring(data));

	self:checkLingquState();
end

function Lua_WulindahuiBoxItem:checkLingquState()
	if DataCenter.WulindahuiData.curChallengeTimes >= self.data then
		local boxRewards = DataCenter.WulindahuiData.boxRewards;
		for i, v in ipairs(boxRewards) do
			if v.obj_id == self.data then
				if v.obj_value == 2 then
					self.box:setAltas("common_atlas_2", "ui_common_baoxiang1_s");
					self.box:setLocation(8, 12, 0);
				else
					self.box:setAltas("common_atlas_2", "ui_common_baoxiang1");
					self.box:setLocation(0, 0, 0);
				end
				self:showRedDot(v.obj_value == 1);
			end
		end
	else
		self.box:setAltas("common_atlas_2", "ui_common_baoxiang1");
		self.box:setLocation(0, 0, 0);
		self:showRedDot(false);
	end
end

function Lua_WulindahuiBoxItem:showRedDot(val)
	if val then
		if self._redDot == nil then
			self._redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 21, 21, 0, 0);
			self._redDot:setDepth(10);
		end
		self._redDot:setEnable(true);
	else
		if self._redDot ~= nil then
			self._redDot:setEnable(false);
		end
	end
end

function Lua_WulindahuiBoxItem:onBoxClick(go)
	if DataCenter.WulindahuiData.curChallengeTimes < self.data then
		OperateAlert.show(LanUtil.getValue(122807));

		local config = DataCenter.WulindahuiUtil:getFightRewardId(self.data);
		Lua_WindowUtil.openWin("Lua_ShowRewardWindow", WinParam.ACTION_OPEN, {title = config.name, rewardId = config.reward_id});
		return;
	end

	local boxRewards = DataCenter.WulindahuiData.boxRewards;
	if boxRewards ~= nil then
		for i, v in ipairs(boxRewards) do
			if v.obj_id == self.data then
				if v.obj_value == 2 then
					OperateAlert.show(LanUtil.getValue(122806));
				elseif v.obj_value == 1 then
					local bagData = DataCenter.packData:getBagType(Lua_PackData.BAG_PACK);
					if bagData:getLeftSize() <= 0 and Lua_WindowUtil.isWindowShowing("Lua_TipsWindow") == false and
						Lua_WindowUtil.isWindowShowing("Lua_PackWindow") == false then
							DataCenter.packData:showFullBagTip(Lua_PackData.BAG_PACK);
					else
						local cmd = ProtoPublic_pb.Proto10400302();
						cmd.box_index = tonumber(self.data)
						sendMsg(10400302, cmd);
					end
				elseif v.obj_value == 0 then
					OperateAlert.show(LanUtil.getValue(122807));
				end

				if v.obj_value ~= 1 then
					local config = DataCenter.WulindahuiUtil:getFightRewardId(self.data);
					Lua_WindowUtil.openWin("Lua_ShowRewardWindow", WinParam.ACTION_OPEN, {title = config.name, rewardId = config.reward_id});
				end
				return;
			end
		end
	end
end

function Lua_WulindahuiBoxItem:onLoadCompleteImg()
	self.box:resetSize();
end

function Lua_WulindahuiBoxItem:dispose()
	if self._redDot ~= nil then
		self._redDot:dispose();
		self._redDot = nil;
	end

	self:superCall("dispose");
end