checkRequire("Lua_FightingResultBaseWindow");
Lua_WulinFightingEndWindow = class("Lua_WulinFightingEndWindow", Lua_FightingResultBaseWindow);
function Lua_WulinFightingEndWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_WulinFightingEndWindow";
	self.winTitleAtlas = "ui_zhujiemian_z_zdcg"; -- 战斗成功
	self.tieTitleAtlas = "ui_zhujiemian_z_zdsb"; -- 战斗失败
	self.failTitleAtlas = "ui_zhujiemian_z_zdsb"; -- 战斗失败
end

function Lua_WulinFightingEndWindow:buildShowItem()
	self:superCall("buildShowItem");
	
	self.tipsLab = UICreate.createLabel(self.content, "", 0, 118, 300, 30, 30);
	self.tipsLab.name = "tipsLab";
	self.tipsLab.pivot = UIWidget.Pivot.Center;
	self.tipsLab.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.tipsLab:setDepth(2);
	
	self.integralLab = UICreate.createLabel(self.content, "", 0, 24, 300, 30, 32);
	self.integralLab.name = "integralLab";
	self.integralLab.pivot = UIWidget.Pivot.Center;
	self.integralLab.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.integralLab:setDepth(1);

	self.leftIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_title_3", -335, -53, 0, 0);
	self.leftIcon.name = "leftIcon";
	self.leftIcon:setSacle(0.8, 0.8, 0.8);
	self.leftIcon:setDepth(1);

	self.rightIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_title_3", 335, -53, 0, 0);
	self.rightIcon.name = "rightIcon";
	self.rightIcon:setSacle(-0.8, 0.8, 0.8);
	self.rightIcon:setDepth(1);
	
	self.honorLab = UICreate.createLabel(self.content, "", -238, -55, 300, 30, 32);
	self.honorLab.name = "honorLab";
	self.honorLab.pivot = UIWidget.Pivot.Left;
	self.honorLab.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.honorLab:setDepth(1);
	
	self.expLab = UICreate.createLabel(self.content, "", -12, -55, 300, 30, 32);
	self.expLab.name = "expLab";
	self.expLab.pivot = UIWidget.Pivot.Left;
	self.expLab.overflowMethod = UILabel.Overflow.ResizeFreely;
	self.expLab:setDepth(1);

	self:addLuaEvent("rWulinChallengeEnd", self, self.onWulinChallengeEnd);
end

function Lua_WulinFightingEndWindow:onWulinChallengeEnd(msg)
	if msg == nil then
		return;
	end

	if msg.result_state == 1 then
		self:setShowInfo(1, DataCenter.WulindahuiUtil.fightEndTickTime);
		if msg.role_name ~= nil then
			self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(122808), msg.role_name);
		end
	elseif msg.result_state == 0 then
		self:setShowInfo(-1, DataCenter.WulindahuiUtil.fightEndTickTime)
		if msg.role_name ~= nil then
			self.tipsLab.text = LanUtil.formateStr(LanUtil.getValue(122809), tostring(msg.role_name));
		end
	end

	local num = (msg.point ~= nil) and msg.point or 0;
	self.integralLab.text = LanUtil.getValue(122810) .. Lua_CommonUtil.getNumberTrans(num);
	
	num = (msg.honor ~= nil) and msg.honor or 0;
	self.honorLab.text = LanUtil.getValue(122811) .. Lua_CommonUtil.getNumberTrans(num);
	
	num = (msg.exp ~= nil) and msg.exp or 0;
	self.expLab.text = LanUtil.getValue(122812) .. Lua_CommonUtil.getNumberTrans(num);
end

function Lua_WulinFightingEndWindow:dispose()
	sendMsg(10400902); -- 退出场景
	self:superCall("dispose");
end