-- 武林大会对战UI
checkRequire("Lua_WulindahuiProxy");
checkRequire("Lua_CountDownAnimation");
Lua_WulinFightingWindow = class("Lua_WulinFightingWindow", Lua_FullSizeWindow);
function Lua_WulinFightingWindow:ctor()
	self:superCall("ctor", false, false, 500, false, false, false);

	self.windowName = "Lua_WulinFightingWindow";
	self.skinName = "WulinFightingInfoWindow_skin";
end

function Lua_WulinFightingWindow:buildShowItem()
	self:superCall("buildShowItem");

	DataCenter.hook:stop(true);

	self.ownMpBar:setBgSacle(1, -1);
	self.ownMpBar:setBarSacle(1, -1);
	self.targetHpBar:setBgSacle(-1, 1);
	self.targetHpBar:setBarSacle(-1, 1);
	self.targetMpBar:setBgSacle(-1, -1);
	self.targetMpBar:setBarSacle(-1, -1);
	self.targetHpBar:setBarPosOffset(106, 0);
	self.targetMpBar:setBarPosOffset(106, 0);

	self.timeObj:SetActive(false);
	self.skipBtn:setEnable(false);

	Lua_WindowUtil.openWin("Lua_WulinMatchCompleteCDWindow", WinParam.ACTION_CLOSE, nil);
	Lua_WindowUtil.openWin("Lua_WulinRewardsWindow", WinParam.ACTION_CLOSE, nil);
	Lua_WindowUtil.openWin("Lua_WulinRankWindow", WinParam.ACTION_CLOSE, nil);
	Lua_WindowUtil.openWin("Lua_CopyWulinWindow", WinParam.ACTION_CLOSE, nil);

	DataCenter.mountData:sUse(DataCenter.roleData.mount_id, 0);
	Lua_MsgUtil.callFunc("SETSKILLMENUSTATE", 3);

	self.ownForceNum = Lua_NumberImage.new(self.content);
	self.ownForceNum.prefix = "a_";
	self.ownForceNum.numWidth = 20;
	self.ownForceNum:setDepth(3);
	self.ownForceNum:setLocation(-455, 330.5, 0);

	self.targetForceNum = Lua_NumberImage.new(self.content);
	self.targetForceNum.prefix = "a_";
	self.targetForceNum.numWidth = 20;
	self.targetForceNum:setDepth(3);
	self.targetForceNum:setLocation(391, 330.5, 0);

	-- 遮罩，倒计时完去除
	self.blackBg = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_black_50", 0, 0, 1280, 720);
	self.blackBg.name = "blackBg";
	self.blackBg.alpha = 0.5;
	self.blackBg:setDepth(10);
	self.blackBg:setEnable(true);
	self.blackBg:addClickFuntion(self, self.onBlackBgClick);
	self.backBtn:addClickFuntion(self, self.onExitBtnClick); -- 离开
	self.skipBtn:addClickFuntion(self, self.onSkipBtnClick); -- 跳过

	self:onUpdateFightTimeInfo();

	self:addLuaEvent("rUpdateChallengeInfo", self, self.onUpdateFightInfo);
	self:addLuaEvent("rWulinChallengeInfo", self, self.onUpdateFightTimeInfo);
end

function Lua_WulinFightingWindow:onBlackBgClick(go)
end

function Lua_WulinFightingWindow:onExitBtnClick(go)
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des =LanUtil.getValue(122813), type = 1, subFun = self.ExitBtnClick});
end

function Lua_WulinFightingWindow:ExitBtnClick(go)
	sendMsg(10400902);
end

function Lua_WulinFightingWindow:onUpdateFightTimeInfo()
	self:updateFightPlayerInfo();

	local variable = 0;
	local career;
	local profession;
	if DataCenter.WulindahuiData.firstRoleInfo ~= nil then
		self.ownNameTxt.text = DataCenter.WulindahuiData.firstRoleInfo.role_name;
		self.ownLvTxt.text = DataCenter.WulindahuiData.firstRoleInfo.role_level;

		variable = tonumber(DataCenter.WulindahuiData.firstRoleInfo.role_force);
		self.ownForceNum.num = variable == nil and 0 or variable;
		self.ownForceNum:setNumScale(0.7, 0.7);

		-- 职业，职业（几转）
		career = DataCenter.WulindahuiData.firstRoleInfo.role_career;
		profession = DataCenter.WulindahuiData.firstRoleInfo.profession;
		self.ownCareerLab.text = Lua_ThingDefine.getJobName(career, profession);

		if isHeadReplaceOpen() then
			self:updateFirstRoleHead();
		else
			self.ownHeadIcon:setUrl(Lua_ThingDefine.getHeadIconUrlByCareer(career, profession));
		end
	end

	if DataCenter.WulindahuiData.secRoleInfo ~= nil then
		self.targetNameTxt.text = DataCenter.WulindahuiData.secRoleInfo.role_name;
		self.targetLvTxt.text = DataCenter.WulindahuiData.secRoleInfo.role_level;

		variable = tonumber(DataCenter.WulindahuiData.secRoleInfo.role_force);
		self.targetForceNum.num = variable == nil and 0 or variable;
		self.targetForceNum:setNumScale(0.7, 0.7);
		
		-- 职业，职业（几转）
		career = DataCenter.WulindahuiData.secRoleInfo.role_career;
		profession = DataCenter.WulindahuiData.secRoleInfo.profession;
		self.targetCareerLab.text = Lua_ThingDefine.getJobName(career, profession);

		if isHeadReplaceOpen() then
			self:updateSecRoleHead();
		else
			self.targetHeadIcon:setUrl(Lua_ThingDefine.getHeadIconUrlByCareer(career, profession));
		end
	end

	local num = DataCenter.WulindahuiData.countDownTime;
	if num ~= nil then
		if num > 0 then
			if GlobalVar.hooking == true then
				DataCenter.hook:stop(true);
			end
			self.timeObj:SetActive(false);
			self.blackBg:setEnable(true);

			if self.countDownAni == nil then
				self.countDownAni = Lua_CountDownAnimation.new(self.content, self, self.addFightEndTimer);
				self.countDownAni:setDepth(10);
			end
			self.countDownAni:playCountDown(num, 1);
		else
			self:addFightEndTimer();
		end
	end
end

function Lua_WulinFightingWindow:updateFirstRoleHead()
	local role_head = DataCenter.WulindahuiData.firstRoleInfo.role_head_name;
	if role_head ~= nil and role_head ~= "" then
		local isDefault = DataCenter.roleData:isDefaultHead(DataCenter.WulindahuiData.firstRoleInfo.role_career, role_head);
		if isDefault == true then
			self.ownHeadIcon:setUrl(Lua_ThingDefine.getHeadIconUrlByCustom(role_head, 0));
		else
			self.ownHeadIcon:setUrl(role_head, 99, true);
			-- self.ownHeadIcon:setRoundSize(1, 0.5, 0.5, 0.5); -- 菱形
			self.ownHeadIcon:setRoundSize(0, 0.5, 0.5, 0.25); -- 圆形
			self.ownHeadIcon:SetDimensions(110, 105);
		end
	end
end

function Lua_WulinFightingWindow:updateSecRoleHead()
	local role_head = DataCenter.WulindahuiData.secRoleInfo.role_head_name;
	if role_head ~= nil and role_head ~= "" then
		local isDefault = DataCenter.roleData:isDefaultHead(DataCenter.WulindahuiData.secRoleInfo.role_career, role_head);
		if isDefault == true then
			self.targetHeadIcon:setUrl(Lua_ThingDefine.getHeadIconUrlByCustom(role_head, 0));
		else
			self.targetHeadIcon:setUrl(role_head, 99, true);
			-- self.targetHeadIcon:setRoundSize(1, 0.5, 0.5, 0.5); -- 菱形
			self.targetHeadIcon:setRoundSize(0, 0.5, 0.5, 0.25); -- 圆形
			self.targetHeadIcon:SetDimensions(110, 105);
		end
	end
end

function Lua_WulinFightingWindow:onUpdateFightInfo()
	self:updateFightPlayerInfo();
end

-- 更新玩家信息，显示血量
function Lua_WulinFightingWindow:updateFightPlayerInfo()
	local num = DataCenter.WulindahuiData.firstCurBlood;
	local maxNum = DataCenter.WulindahuiData.firstMaxBlood;
	self.ownHpBar:setText(num .. "/" .. maxNum);
	self.ownHpBar:setMaxValue(maxNum);
	self.ownHpBar:setValue(num);

	num = DataCenter.WulindahuiData.firstCurMagic;
	maxNum = DataCenter.WulindahuiData.firstMaxMagic;
	self.ownMpBar:setText(num .. "/" .. maxNum);
	self.ownMpBar:setMaxValue(maxNum);
	self.ownMpBar:setValue(num);

	num = DataCenter.WulindahuiData.secCurBlood;
	maxNum = DataCenter.WulindahuiData.secMaxBlood;
	self.targetHpBar:setText(num .. "/" .. maxNum);
	self.targetHpBar:setMaxValue(maxNum);
	self.targetHpBar:setValue(num);

	num = DataCenter.WulindahuiData.secCurMagic;
	maxNum = DataCenter.WulindahuiData.secMaxMagic;
	self.targetMpBar:setText(num .. "/" .. maxNum);
	self.targetMpBar:setMaxValue(maxNum);
	self.targetMpBar:setValue(num);
end

function Lua_WulinFightingWindow:addFightEndTimer()
	if self.countDownAni ~= nil then
		self.countDownAni:dispose();
		self.countDownAni = nil;
	end
	if GlobalVar.hooking == false then
		DataCenter.hook:start();
	end
	self.timeObj:SetActive(true);
	self.blackBg:setEnable(false);
	
	local num = DataCenter.WulindahuiData.reduiseTime;
	self.endTimeTxt.text = TimeTransform.getInstance():transSeconds1(num, true);
	if num > 0 then
		self:startTimer();
		self:updateTimer();
	else
		self:endTimer();
	end
end

function Lua_WulinFightingWindow:startTimer()
	if self.bEnd ~= true then
		self.bEnd = true;
		Lua_CommonUtil.addTimer("Lua_WulinFightingWindow", 1, self, self.updateTimer);
	end
end

-- 战斗结束倒计时
function Lua_WulinFightingWindow:updateTimer()
	local num = DataCenter.WulindahuiData.reduiseTime;
	self.endTimeTxt.text = TimeTransform.getInstance():transSeconds1(num, true);
	if num <= 0 then
		self:endTimer();
	end
end

function Lua_WulinFightingWindow:endTimer()
	if self.bEnd == true then
		self.bEnd = false;
		Lua_CommonUtil.removeTimer(self, self.updateTimer);
	end
end

function Lua_WulinFightingWindow:dispose()
	if self.blackBg ~= nil then
		self.blackBg:dispose();
		self.blackBg = nil;
	end
	if self.countDownAni ~= nil then
		self.countDownAni:dispose();
		self.countDownAni = nil;
	end
	self:endTimer();
	DataCenter.hook:stop(true);
	DataCenter.WulindahuiData:resetChallengeInfo();

	self:superCall("dispose");
end