checkRequire("Lua_ChangeJobUtil");
Lua_WulinRankWindow = class("Lua_WulinRankWindow", Lua_ThirdSizeWindow)
function Lua_WulinRankWindow:ctor()
	self:superCall("ctor", true, 3500, true, LanUtil.getValue(122820));

	self.windowName = "Lua_WulinRankWindow";
	self.skinName = "WulinRankWindow_skin";
	self.w = 916;
	self.h = 574;
end

function Lua_WulinRankWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardsList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 878, 360));
	self.rewardsList:setLocation(0, -24, 0);
	self.rewardsList:setListCell(Lua_WulinRankItem, 72, 878, 1);

	self:addLuaEvent("rWulinRankInfo", self, self.onWulinRankInfo);
	sendMsg(10400304); -- 获取武林大会排行榜数据
end

function Lua_WulinRankWindow:onWulinRankInfo(msg)
	local arr = Array();
	for k,v in ipairs(msg.rank_info) do
		arr:add(v); 
	end
	self.rewardsList:setLuaArrayData(arr, false);

	if msg.our_rank.rank == 0 then
		self.myrankTxt.text = LanUtil.getValue(122814);
	else
		self.myrankTxt.text = msg.our_rank.rank;
	end 
end

function Lua_WulinRankWindow:dispose()
    if self.rewardsList ~= nil then
    	self.rewardsList:dispose()
    	self.rewardsList = nil;
    end

    self:superCall("dispose");
end





--------------------------------------------------





Lua_WulinRankItem = class("Lua_WulinRankItem", Lua_ListCell);
function Lua_WulinRankItem:ctor(p)
	self:superCall("ctor", p, "WulinRankItem_skin");
end

function Lua_WulinRankItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_WulinRankItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	if data.rank <= 3 then
		self.rankIcon:setAltas("leaderBoard_atlas", "ui_paihang_widget_no" .. data.rank);
		self.rankTxt.text = "";
	else
		self.rankTxt.text = data.rank;
	end
	self.rankBg:setEnable(data.rank <= 3);
	self.rankIcon:setEnable(data.rank <= 3);

	self.playerNameTxt.text = data.name;
	self.jobTxt.text = Lua_ThingDefine.getJobName(tonumber(data.career), tonumber(data.profession));
	self.fightTxt.text = data.force;
	self.IntegralTxt.text = data.wulin_point; -- 武林大会积分
end

function Lua_WulinRankItem:dispose()
	self:superCall("dispose");
end