Lua_WulinRewardsWindow = class("Lua_WulinRewardsWindow", Lua_ThirdSizeWindow)
function Lua_WulinRewardsWindow:ctor()
	self:superCall("ctor", true, 3500, true, LanUtil.getValue(120932));

	self.windowName = "Lua_WulinRewardsWindow";
	self.skinName = "WulinRewardsWindow_skin";
	self.w = 904;
	self.h = 553;
end

function Lua_WulinRewardsWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.rewardsList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 878, 475));
	self.rewardsList:setLocation(0, -27, 0);
	self.rewardsList:setListCell(Lua_WulinRewardItem, 88, 878, 1);
	self.rewardsList:setLuaArrayData(DataCenter.WulindahuiUtil.rankRewardsArr, false);
end

function Lua_WulinRewardsWindow:dispose()
	if self.rewardsList ~= nil then
		self.rewardsList:dispose()
		self.rewardsList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_WulinRewardItem = class("Lua_WulinRewardItem", Lua_ListCell);
function Lua_WulinRewardItem:ctor(p)
	self:superCall("ctor", p, "WulinRewardItem_skin");
end

function Lua_WulinRewardItem:buildShowItem()
	self:superCall("buildShowItem");

	self.tipsLab.text = LanUtil.getValue(122818);

	self.rItem = Lua_RewardItem.new(self.content);
	self.rItem:setMaxShow(5);
	self.rItem:setDepth(10);
	self.rItem:setClickWin(true);
	self.rItem:setMouseEnble(true);
	self.rItem:setItemScale(0.8,0.8);
	self.rItem:setLocation(-33, 5, 0);
end

function Lua_WulinRewardItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end

	if data.isShow then
		self.rankIcon:setAltas("leaderBoard_atlas", "ui_paihang_widget_no" .. data.section)
		self.rankLab.text = "";
	else
		self.rankLab.text = data.section;
	end
	self.rankObj:SetActive(data.isShow);

	self.rItem:setRewardByRewardList(Array(data.rewardId));
end

function Lua_WulinRewardItem:dispose()
    self:superCall("dispose");
end